//+------------------------------------------------------------------+
//|                                            _SOL_Box_Break_PV.mq4 |
//|                                                                  |
//|               Made/Modified by sh _j .                           |
//+------------------------------------------------------------------+
#property copyright "Morning Star"
#property link      "http://Grand Forex.ir"

// modified for last day start for asian session on MIG by Solaiman
// adding fib / day pivots by Solaiman

#property indicator_chart_window
#property indicator_buffers   8

#property indicator_color1    Red
#property indicator_color2    OrangeRed
#property indicator_color3    Chocolate
#property indicator_color4    Indigo
#property indicator_color5    DodgerBlue
#property indicator_color6    RoyalBlue
#property indicator_color7    MediumBlue

#property indicator_color8    LightGray
 
extern int    NumberOfDays = 50;        
extern string AsiaBegin    = "23:00";   
extern string AsiaEnd      = "11:00";   
extern color  AsiaColor    = SlateGray ; // DimGray; 
extern string EurBegin     = "08:00";   
extern string EurEnd       = "18:00";   
extern color  EurColor     = Gray ; // MidnightBlue;       
extern string USABegin     = "14:00";   
extern string USAEnd       = "23:59";   
extern color  USAColor     = DimGray ; // DarkSlateBlue; 

extern double TimeShift    = -2.00 ;

extern string KeyOpenTime  = "23:00" ;

extern bool   BOX_DRAW     = true ;

double pvh3[] ;
double pvh2[] ;
double pvh1[] ;
double pv[] ;
double pvl1[] ;
double pvl2[] ;
double pvl3[] ;

double dopen[] ;

static double po , ph , pl , pc ;
   int sptr ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {

   sptr = -10 ;
   po = 0 ; 
   ph = 0 ;
   pl = 0 ;
   pc = 0 ;
   
   SetIndexBuffer( 0 , pvh3 ) ;
   SetIndexBuffer( 1 , pvh2 ) ;
   SetIndexBuffer( 2 , pvh1 ) ;
   SetIndexBuffer( 3 , pv ) ;
   SetIndexBuffer( 4 , pvl1 ) ;
   SetIndexBuffer( 5 , pvl2 ) ;
   SetIndexBuffer( 6 , pvl3 ) ;
   SetIndexBuffer( 7 , dopen ) ;
   
   SetIndexStyle( 0 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 1 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 2 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 3 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 4 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 5 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 6 , DRAW_LINE , EMPTY , 2 ) ;
   SetIndexStyle( 7 , DRAW_LINE , EMPTY , 3 ) ;
   
   SetIndexEmptyValue( 0, 0) ;
   SetIndexEmptyValue( 1, 0) ;
   SetIndexEmptyValue( 2, 0) ;
   SetIndexEmptyValue( 3, 0) ;
   SetIndexEmptyValue( 4, 0) ;
   SetIndexEmptyValue( 5, 0) ;
   SetIndexEmptyValue( 6, 0) ;
   SetIndexEmptyValue( 7, 0) ;
   
  DeleteObjects();
  
  if ( BOX_DRAW )
   for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("AS"+i, AsiaColor);
    CreateObjects("EU"+i, EurColor);
    CreateObjects("US"+i, USAColor);
  }
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  DeleteObjects();
  Comment("");
}

 
void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() {
  for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("AS"+i);
    ObjectDelete("EU"+i);
    ObjectDelete("US"+i);
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {

   datetime t1 , t2 , stw , dt=TimeCurrent();

   for (int i = NumberOfDays ; i >= 0 ; i-- ) {

      dt = iTime(NULL,PERIOD_D1,i) ;
      // if ( TimeDayOfWeek( dt ) == 1 ) stw = iTime(NULL,PERIOD_D1,i+) ;
      if ( AsiaBegin <= "04:00" ) t1 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+AsiaBegin) + TimeShift * 3600 ;
      else t1 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+AsiaBegin) - 24*60*60 + TimeShift * 3600 ;
      t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+AsiaEnd) + TimeShift * 3600 ;
      DrawObjects(dt, "AS"+i, t1, t2 );

      t1 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+EurBegin) + TimeShift * 3600 ;
      t2 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+EurEnd) + TimeShift * 3600 ;
      DrawObjects(dt, "EU"+i, t1 , t2 );

      t1 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+USABegin) + TimeShift * 3600 ;
      if ( USAEnd >= "20:00" ) t2 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+USAEnd) + TimeShift * 3600 ;
      else t2 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+USAEnd) + 24*60*60 + TimeShift * 3600 ;
      DrawObjects(dt, "US"+i, t1 , t2 );

      /*
      dt=decDateTradeDay(dt);
      while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
      */
      }
      
   for ( int j = 0 ; j < Bars && pv[j] == 0 ; j ++ ) int ptr = j ;
   
   if ( ptr > 1 ) for ( j = ptr-1 ; j >= 0 ; j -- )
         {
         pvh3[j] = pvh3[j+1] ;
         pvh2[j] = pvh2[j+1] ;
         pvh1[j] = pvh1[j+1] ;
         pv[j]   = pv[j+1] ;
         pvl1[j] = pvl1[j+1] ;
         pvl2[j] = pvl2[j+1] ;
         pvl3[j] = pvl3[j+1] ;
         
         dopen[i] = dopen[i+1] ;
         }
      
}

////////////////////////////////////////////////////////////////////////
  
void DrawObjects(datetime dt, string no, datetime tb, datetime te) {
  datetime t1, t2 ,ts, ts1;
  double   p1, p2 ,p3 , ps , ps1;
  int      b1, b2 , bs, bs1;

  ts = StrToTime(TimeToStr(dt, TIME_DATE)+" "+KeyOpenTime) + TimeShift * 3600 ;
  ts1 = StrToTime(TimeToStr(dt, TIME_DATE)+" "+KeyOpenTime) - 24*60*60 + TimeShift * 3600 ;

  bs = iBarShift(NULL, 0, ts , false ) ;
  ps = Open[bs] ;

  bs1 = iBarShift(NULL, 0, ts1 , false ) ;
  ps1 = Open[bs1] ;

  t1 = tb;
  t2 = te;
  b1=iBarShift(NULL, 0, t1 , false ) ;
  b2=iBarShift(NULL, 0, t2 , false ) ;
  p1=High[iHighest(NULL, 0, MODE_HIGH, b1-b2, b2)] ;
  p2=Low [iLowest (NULL, 0, MODE_LOW , b1-b2, b2)] ;
  p3=Close[b2+1] ;
  
  ObjectSet(no, OBJPROP_TIME1 , t1) ;
  ObjectSet(no, OBJPROP_PRICE1, p1) ;
  ObjectSet(no, OBJPROP_TIME2 , t2) ;
  ObjectSet(no, OBJPROP_PRICE2, p2) ;
  
  if ( ph != 0 && pl != 0 && pc != 0 )
    {
    //double mypv = ( ph + pl + pc ) / 3 ;
    double mypv = ( ph + pl ) / 2 ;
    
    double hl = ph - pl ;
    
    int s = b1 ;
    if ( sptr >= 0 ) s = sptr ;
    
    for ( int j = s ; j >= b2 ; j -- )
      {
      
      if ( ts <= tb )
         {
         dopen[j] = ps ;
         }
      else if ( ts <= te )
         {
         if ( ts <= Time[j] ) dopen[j] = ps ;
         else dopen[j] = ps1 ;
         }
      else
         {
         dopen[j] = ps1 ;
         }

      pvh3[j] = mypv + hl * 0.786 ;
      pvh2[j] = mypv + hl * 0.618 ;
      pvh1[j] = mypv + hl * 0.382 ;
      pv[j]   = mypv ;
      pvl1[j] = mypv - hl * 0.382 ;
      pvl2[j] = mypv - hl * 0.618 ;
      pvl3[j] = mypv - hl * 0.786 ;

      }
   }
   
   
  /*if (!( TimeDayOfWeek( dt ) <= 2 && TimeHour( te ) <= 12 ))*/
    if ( b2 > 0 )
      {
      ph = p1 ;
      pl = p2 ;
      pc = p3 ;
      sptr = b2 ;
      }
}

/////////////////////////////////////////////

datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

